/**
 *  Copyright (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  Licensed under the GPL, Version 3.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/gpl.html
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 * --------------------------------------------------------------------------
 *  版权 (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  本开源软件遵循 GPL 3.0 协议;
 *  如果您不遵循此协议，则不被允许使用此文件。
 *  你可以从下面的地址获取完整的协议文本
 *
 *       http://www.gnu.org/licenses/gpl.html
 */
package org.tinygroup.pool;

/**
 * Created by IntelliJ IDEA. User: luoguo Date: 11-3-29 Time: 下午2:14 To change
 * this template use File | Settings | File Templates.
 */
public interface ObjectProvider<T> {
	int DEFAULT_IDLE_ACTION_INTERVAL = 10000;

	/**
	 * 创建一个对象
	 * 
	 * @return
	 */
	T createObject();

	/**
	 * 空闲动作间隔，单位ms，如果是0，则不执行空闲动作
	 * 
	 * @return
	 */
	int getIdleActionInterval();

	/**
	 * 测试对象
	 * 
	 * @param object
	 * @return
	 */
	boolean test(T object);

	/**
	 * 释放对象
	 */
	void releaseObject(T object);

	/**
	 * 当达到空闲时间后执行此操作---如发送心跳包等
	 * 
	 * @param obect
	 */
	void idleAction(T obect);
}
