/**
 *  Copyright (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  Licensed under the GPL, Version 3.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/gpl.html
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 * --------------------------------------------------------------------------
 *  版权 (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  本开源软件遵循 GPL 3.0 协议;
 *  如果您不遵循此协议，则不被允许使用此文件。
 *  你可以从下面的地址获取完整的协议文本
 *
 *       http://www.gnu.org/licenses/gpl.html
 */
package org.tinygroup.pool;

/**
 * Created by IntelliJ IDEA.
 * User: luoguo
 * Date: 11-3-29
 * Time: 下午4:49
 * To change this template use File | Settings | File Templates.
 */
public interface PoolMonitor<T> {
	/**
	 * 获取当前池大小
	 * @return Current size of the pool.
	 */
	int getCurrentPoolSize();

	/**
	 * 获取池内空闲连接数据
	 * @return Number of free connections in the pool
	 */
	int getIdleSize();

	/**
	 * 获取池内正在使用的连接数
	 * @return Vector containing the connections that are currently in use.
	 */
	int getUsingSize();

	/**
	 * 返回池名称
	 * This method returns the name of the pool
	 */
	String getName();

	/**
	 * 返回池状态
	 *
	 * @return
	 */
	int getPoolState();
}
